"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const highlighter_1 = require("../highlighter");
/**
 * `graphql-logging` middleware
 * Based on this post: https://www.reddit.com/r/Strapi/comments/fzg4j6/comment/fn9eulv/
 */
exports.default = async (ctx, next) => {
    var _a;
    // only log graphql post requests
    if (ctx.request.url === '/graphql' && ctx.request.method === 'POST') {
        await next();
        const query = (_a = ctx.request.body) === null || _a === void 0 ? void 0 : _a.query;
        // don't print huge introspection queries
        if (query.startsWith("query IntrospectionQuery ")) {
            console.log("Introspection query ignored");
        }
        else {
            // print highlighted query and response
            console.log(highlighter_1.Highlighter.highlight(query, "graphql"));
            console.log(highlighter_1.Highlighter.highlight(ctx.body, "json"));
        }
    }
    else {
        await next();
    }
};
